#ifndef __FRIENDLYELEC_BOARDTYPE_H__
#define __FRIENDLYELEC_BOARDTYPE_H__

#include <stdio.h>
#include <string.h>
#include <unistd.h> 
#include <stdlib.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#include <sys/ioctl.h> 
#include <fcntl.h>
#include <linux/fs.h> 
#include <errno.h> 
#include <stdio.h>
#include <sys/utsname.h>

#define PORT0 (0)
#define PORT1 (1)
#define PORT2 (2)
#define PORT3 (3)
#define PORT4 (4)
#define PORT5 (5)

typedef struct {
	char kernelHardware[255];
	int kernelRevision;
	int boardTypeId;
	char boardDisplayName[255];
	char allwinnerBoardID[255];
	int nicCount;
} BoardHardwareInfo;

#define S3C6410_COMMON (6410)
#define S5PV210_COMMON (210)
#define S5P4412_COMMON (4412)
#define S5P4418_BASE (4418)
#define NanoPi2 (S5P4418_BASE+0)
#define NanoPC_T2 (S5P4418_BASE+1)
#define NanoPi_S2 (S5P4418_BASE+2)
#define Smart4418 (S5P4418_BASE+3)
#define NanoPi2_Fire (S5P4418_BASE+4)
#define NanoPi_M2 (S5P4418_BASE+5)
#define NanoPi_M2A (S5P4418_BASE+6)
#define Smart4418SDK (S5P4418_BASE+7)
#define SOM_4418 (S5P4418_BASE+8)
#define S5P4418_MAX SOM_4418

//s5p6818
#define S5P6818_BASE (6818)
#define NanoPC_T3 (S5P6818_BASE+1)
#define NanoPi_M3B (S5P6818_BASE+2)
#define Smart6818 (S5P6818_BASE+3)
#define NanoPC_T3T (S5P6818_BASE+4)
#define NanoPi_Fire3 (S5P6818_BASE+5)
#define NanoPi_M3 (S5P6818_BASE+7)
#define S5P6818_MAX NanoPi_M3

//s3c2451
#define S3C2451_BASE (2451)
#define S3C2451_COMMON (S3C2451_BASE+0)


//allwinner
#define ALLWINNER_BASE (7000)
#define NanoPi_M1 (ALLWINNER_BASE+1)
#define NanoPi_NEO (ALLWINNER_BASE+2)
#define NanoPi_NEO_Air (ALLWINNER_BASE+3)
#define NanoPi_M1_Plus (ALLWINNER_BASE+4)
#define NanoPi_A64 (ALLWINNER_BASE+5)
#define NanoPi_NEO2 (ALLWINNER_BASE+6)
#define NanoPi_M1_Plus2 (ALLWINNER_BASE+7)
#define NanoPi_NEO_Plus2 (ALLWINNER_BASE+8)
#define NanoPi_NEO_Core (ALLWINNER_BASE+9)
#define NanoPi_Duo (ALLWINNER_BASE+10)
#define NanoPi_NEO_Core2 (ALLWINNER_BASE+11)
#define NanoPi_K1 (ALLWINNER_BASE+12)
#define NanoPi_K1_Plus (ALLWINNER_BASE+13)
#define NanoPi_Hero (ALLWINNER_BASE+14)
#define NanoPi_Duo2 (ALLWINNER_BASE+15)
#define NanoPi_R1 (ALLWINNER_BASE+16)
#define NanoPi_C3 (ALLWINNER_BASE+17)
#define NanoPi_NEO2_Black (ALLWINNER_BASE+18)
#define NanoPi_NEO_S (ALLWINNER_BASE+19)
#define ZeroPi (ALLWINNER_BASE+20)
#define NanoPi_R1S_H3 (ALLWINNER_BASE+21)
#define NanoPi_R1S_H5 (ALLWINNER_BASE+22)
#define NanoPi_NEO_Plus2_H3 (ALLWINNER_BASE+23)
#define ALLWINNER_MAX NanoPi_R1S_H5

//amlogic
#define AMLOGIC_BASE (8000)
#define NanoPi_K2 (AMLOGIC_BASE+1)

//rk3399
#define RK3399_BASE (9000)
#define NanoPC_T4 (RK3399_BASE+1)
#define NanoPi_M4 (RK3399_BASE+2)
#define NanoPi_NEO4 (RK3399_BASE+3)
#define SOM_RK3399 (RK3399_BASE+4)
#define NanoPi_M4v2 (RK3399_BASE+5)
#define NanoPi_M4B (RK3399_BASE+6)
#define SOM_RK3399v2 (RK3399_BASE+7)
#define NanoPi_NEO4v2 (RK3399_BASE+8)
#define NanoPi_R4S (RK3399_BASE+9)
#define NanoPC_T4B (RK3399_BASE+10)
#define NanoPi_R4S_Plus (RK3399_BASE+11)
#define NanoPi_R4SE (RK3399_BASE+12)
#define RK3399_MAX (RK3399_BASE+12)

//rk3328
#define RK3328_BASE (9500)
#define NanoPi_R2S (RK3328_BASE+1)
#define NanoPi_NEO3_Black (RK3328_BASE+2)
#define NanoPi_NEO3_S (RK3328_BASE+3)
#define NanoPi_NEO3 (RK3328_BASE+4)
#define NanoPi_R2Pro (RK3328_BASE+5)
#define NanoPi_R2C (RK3328_BASE+6)
#define NanoPi_R2C_Plus (RK3328_BASE+7)
#define NanoPi_R2S_Plus (RK3328_BASE+8)
#define Core3328 (RK3328_BASE+9)
#define RK3328_MAX (RK3328_BASE+9)

//rk3568
#define RK3568_BASE (9600)
#define NanoPi_R5S (RK3568_BASE+1)
#define NanoPi_R5C (RK3568_BASE+2)
#define NanoPi_R5S_LTS (RK3568_BASE+3)
#define RK3568_MAX (RK3568_BASE+3)

//rk3588
#define RK3588_BASE (9700)
#define NanoPi_R6S (RK3588_BASE+1)
#define NanoPC_T6 (RK3588_BASE+2)
#define NanoPi_R6C (RK3588_BASE+3)
#define NanoPC_T6_LTS (RK3588_BASE+4)
#define CM3588 (RK3588_BASE+5)
#define RK3588_MAX (RK3588_BASE+5)


extern int getBoardType(BoardHardwareInfo** retBoardInfo);

#endif
